| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Private Member Functions | Static Private Attributes | List of all members
ExtensionManagerFactory Class Reference

A factory class for creating ExtensionManager objects. More...

`#include <ExtensionManagerFactory.h>`

Inheritance diagram for ExtensionManagerFactory:
[legend]

## Detailed Description

A factory class for creating ExtensionManager objects.

Since
  New in Cantera 3.0

Definition at line 18 of file ExtensionManagerFactory.h.

## Public Member Functions
void | deleteFactory () override
| Delete the static instance of this factory.
Public Member Functions inherited from Factory< ExtensionManager >
ExtensionManager * | create (const string &name, Args... args)
| Create an object using the object construction function corresponding to "name" and the provided constructor arguments.
void | reg (const string &name, function< ExtensionManager *(Args...)> f)
| Register a new object construction function.
void | addAlias (const string &original, const string &alias)
| Add an alias for an existing registered type.
string | canonicalize (const string &name)
| Get the canonical name registered for a type.
bool | exists (const string &name) const
| Returns true if `name` is registered with this factory.
Public Member Functions inherited from FactoryBase
virtual | ~FactoryBase ()
| destructor

## Static Public Member Functions
static shared_ptr< ExtensionManager > | build (const string &extensionType)
| Create a new ExtensionManager.
static ExtensionManagerFactory & | factory ()
| Static function that returns the static instance of the factory, creating it if necessary.
Static Public Member Functions inherited from FactoryBase
static void | deleteFactories ()
| static function that deletes all factories in the internal registry maintained in a static variable

## Private Member Functions
| ExtensionManagerFactory ()=default
| Private constructor prevents direct usage.

## Static Private Attributes
static ExtensionManagerFactory * | s_factory = 0
| static member of the single factory instance
static std::mutex | s_mutex
| Decl for locking mutex for thermo factory singleton.

## Additional Inherited Members
Protected Member Functions inherited from Factory< ExtensionManager >
void | addDeprecatedAlias (const string &original, const string &alias)
| Add a deprecated alias for an existing registered type.
Protected Member Functions inherited from FactoryBase
| FactoryBase ()
| Constructor.

## Constructor & Destructor Documentation

## ◆ ExtensionManagerFactory()

ExtensionManagerFactory | ( |  | ) |
| private default

Private constructor prevents direct usage.

## Member Function Documentation

## ◆ build()

static shared_ptr< ExtensionManager > build | ( | const string & | extensionType | ) |
| inline static

Create a new ExtensionManager.

Definition at line 22 of file ExtensionManagerFactory.h.

## ◆ deleteFactory()

void deleteFactory | ( |  | ) |
| override virtual

Delete the static instance of this factory.

Implements FactoryBase.

Definition at line 25 of file ExtensionManagerFactory.cpp.

## ◆ factory()

ExtensionManagerFactory & factory | ( |  | ) |
| static

Static function that returns the static instance of the factory, creating it if necessary.

Definition at line 16 of file ExtensionManagerFactory.cpp.

## Member Data Documentation

## ◆ s_factory

ExtensionManagerFactory * s_factory = 0
| static private

static member of the single factory instance

Definition at line 35 of file ExtensionManagerFactory.h.

## ◆ s_mutex

mutex s_mutex
| static private

Decl for locking mutex for thermo factory singleton.

Definition at line 41 of file ExtensionManagerFactory.h.

The documentation for this class was generated from the following files:

- ExtensionManagerFactory.h
- ExtensionManagerFactory.cpp